#!/usr/bin/perl
package JTeXEditScript;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = (FindScript, CallScript);

BEGIN {
	@ScriptDirs = split("\n", $ENV{'JTeXEditScriptCollection'});
}

my $ScriptName;
sub Find_Script($);
sub Find_Script($) {
	my ($dir) = @_;
	return '' unless(opendir(DIR, $dir));
	my @items = readdir DIR;
	closedir DIR;
	for my $item (@items) {
		next if ($item =~ /^\./);
		my $file = "$dir/$item";
		if (-d $file) {
			my $found = Find_Script($file);
			return $found if $found;
		} elsif ($item eq $ScriptName) {
			return $file;
		}
	}
	return '';
}
sub FindScript($) {
	($ScriptName) = @_;
	for my $root (@ScriptDirs) {
		my $file = Find_Script($root);
		return $file if $file;
	}
	warn "'$ScriptName' not found.\n";
	return '';
}

sub CallScript($@) {
	my ($script, @args) = @_;
	my $script = FindScript($script);
	return '' unless $script;
	my @saveargv = @ARGV;
	@ARGV = @args;
	do $script;
	@ARGV = @saveargv;
}

1;
